/// <reference types="node" />
import { EventEmitter } from 'events';
import * as Model from './model';
export declare const INFINITE_DEPTH = -1;
export declare class TreeView {
    private static addTime;
    private static removeHidden;
    private static getMainPaths;
    lastResult: Model.IResult;
    protected providers: Model.IProviders;
    protected opts: Model.IOpts;
    protected events: EventEmitter;
    constructor(opts?: Model.IOptsParam);
    on(event: 'item', listener: Model.OnItemCtx): this;
    on(event: 'ready' | 'tree', listener: Model.OnTree): this;
    on(event: 'add' | 'change' | 'unlink', listener: Model.OnItem): this;
    on(event: 'all', listener: Model.OnAll): this;
    removeListeners(event: Model.Event): this;
    process(path: string, cb?: Model.ProcessCb): Promise<Model.TreeNode[]>;
    watch(path: string, watchFn?: Model.WatchFn): {
        close: () => void;
    };
    refreshResult(paths: string[] | string): Promise<Model.TreeNode[]>;
    protected inject(): void;
    private formatOpts;
    private getPathFactory;
    private discover;
    private getTreeNode;
    private checkFile;
    private checkDirectory;
    private addError;
    private addFile;
    private addContent;
    private addDir;
    private sort;
    /**
     * Note for 'item' event:
     *  - Emitted file never have `content` property.
     *  - Emitted dir always have `nodes` property equal to an empty array.
     */
    private emit;
    private filterResult;
    private updateResult;
    private extendResult;
}
